Index: CMT/v1r25-branch/source/cmt_use.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_use.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_use.cxx	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -1826,4 +1827,5 @@
   m_located = false;
   m_package = 0;
+  m_project = 0;
   m_index = -1;
 
@@ -1848,4 +1850,5 @@
       m_package = 0;
     }
+  m_project = 0;
 
   version   = "";
@@ -1923,5 +1926,5 @@
 
 //----------------------------------------------------------
-void Use::change_path (const cmt_string& new_path)
+void Use::change_path (const cmt_string& new_path, const Project* project)
 {
   // 
@@ -1929,9 +1932,18 @@
   // where this package/version has been found.
   //
+  if (Cmt::get_debug ())
+    {
+      cout << "|Use::change_path> path: " << new_path
+	   << " project: " << (project ? project->get_cmtpath () : "0")
+	   << " use: " << get_info () << endl;
+    }
 
   real_path = "";
   m_realpath = "";
 
-  if (new_path != "")
+  m_project = 0;
+
+  if (new_path.size () != 0)
+    //  if (new_path != "")
     {
       if ((path.size () > 0) &&
@@ -1951,6 +1963,7 @@
       if (!CmtSystem::realpath_ (real_path, m_realpath))
 	{
-	  CmtError::set (CmtError::file_access_error, "Cannot compute real path `" +
-			 real_path + "'");
+	  CmtError::set (CmtError::file_access_error,
+			 "Cannot compute real path `" + real_path + "': " +
+			 get_info ());
 	  CmtError::print ();
 	  return;
@@ -1958,5 +1971,15 @@
     }
   
+  if (project)
+    m_project = project;
+
   m_located = true;
+
+  if (Cmt::get_debug ())
+    {
+      cout << "<Use::change_path| real_path: " << real_path
+	   << " m_project: " << (m_project ? m_project->get_cmtpath () : "0")
+	   << " use: " << get_info () << endl;
+    }
 }
 
@@ -2347,5 +2370,5 @@
 	  }
 	
-	m_use->change_path (path);
+	m_use->change_path (path, &project);
 
 	m_found = true;
@@ -2355,5 +2378,5 @@
     else if (m_use->alternate_versions.size () > 0)
       {
-	if (m_use->select_alternate ()) 
+	if (m_use->select_alternate (&project)) 
 	  {
 	    if (Cmt::get_debug ())
@@ -2448,7 +2471,5 @@
               cout << "move_to2> " << expanded_path << endl;
             }
-
           change_path (here);
-
           return (true);
         }
@@ -2461,8 +2482,12 @@
                   cout << "move_to5> " << real_path << endl;
                 }
-              
               return (true);
             }
         }
+
+      if (!CmtSystem::cd (here))
+	{
+	  CmtError::set (CmtError::file_access_error, here);
+	}
       return (false);
 //     }
@@ -2482,5 +2507,5 @@
 
 //----------------------------------------------------------
-bool Use::select_alternate ()
+bool Use::select_alternate (const Project* project)
 {
   int i;
@@ -2567,5 +2592,5 @@
                 }
 
-              change_path (alternate_paths[selected_index]);
+              change_path (alternate_paths[selected_index], project);
               return (true);
             }
@@ -3568,10 +3593,19 @@
   offset = "";
 
-  cmtpath = m_realpath.size ()
-    ? Project::find_in_cmt_paths (m_realpath, true)
-    : Project::find_in_cmt_paths (real_path)
-    ;
-  const Project* p = Project::find_by_cmtpath (cmtpath);
-
+  const Project* p (0);
+  if (m_project)
+    {
+      p = m_project;
+      cmtpath = p->get_cmtpath ();
+    }
+  else
+    {
+      cmtpath = m_realpath.size ()
+	? Project::find_in_cmt_paths (m_realpath, true)
+	: Project::find_in_cmt_paths (real_path)
+	;
+      p = Project::find_by_cmtpath (cmtpath);
+  //  const Project* p = Project::find_by_cmtpath (cmtpath);
+    }
   //  if (cmtpath != "")
   if (p != 0)
@@ -3590,6 +3624,7 @@
       else if (!CmtSystem::realpath_ (real_path, offset))
 	{
-	  CmtError::set (CmtError::file_access_error, "Cannot compute real path `" +
-			 real_path + "'");
+	  CmtError::set (CmtError::file_access_error,
+			 "Cannot compute real path `" + real_path + "': " +
+			 get_info ());
 	  CmtError::print ();
 	  return;
@@ -3619,10 +3654,11 @@
 bool Use::get_strategy (const cmt_string& name) const
 {
-  const Project* p =
+  const Project* p = get_project ();
+    /*
     Project::find_by_cmtpath (m_realpath.size ()
 			      ? Project::find_in_cmt_paths (m_realpath, true)
 			      : Project::find_in_cmt_paths (real_path)
 			      );
-  //  const Project* p = Project::find_by_cmtpath (Project::find_in_cmt_paths (real_path));
+    */
 
   bool strategy;
@@ -3705,5 +3741,6 @@
   buffer += "\n";
 
-  if (located ())
+  if (m_located)
+    //  if (located ())
     {
       buffer += "macro ";
@@ -3725,5 +3762,4 @@
 	  buffer += package_name;
 	}
-      //      if (style != no_version_style)
       if (structuring_style == with_version_directory)
 	{
@@ -3733,4 +3769,22 @@
       buffer += "\"";
       buffer += "\n";
+    }
+
+  if (action_setup == Cmt::get_action () &&
+      Requirements == Cmt::get_print_mode ())
+    {
+      //cerr << "|Use::fill_standard_macros> Checking for " << prefix << "CONFIG" << endl;
+      if (!discarded &&
+	  get_package_name () != "cmt_standalone" &&
+	  get_strategy ("SetupConfig"))
+	{
+	  buffer += "macro ";
+	  buffer += prefix;
+	  buffer += "CONFIG";
+	  buffer += " \"";
+	  buffer += CmtSystem::get_cmt_config ();
+	  buffer += "\"";
+	  buffer += "\n";
+	}
     }
 
@@ -3764,5 +3818,13 @@
   buffer += "\n";
   
-  Project* p = Project::find_by_cmtpath (cmtpath);
+  const Project* p = m_project
+    ? m_project
+    : Project::find_by_cmtpath (cmtpath)
+    ;
+  /*
+  const Project* p (m_project);
+  if (!p)
+    p = Project::find_by_cmtpath (cmtpath);
+  */
 
   buffer += "macro ";
@@ -4520,8 +4582,11 @@
   static const cmt_string null = "";
 
+  return m_package ? m_package->get_name () : null ;
+  /*
   Package* p = m_package;
   if (p == 0) return (null);
 
   return (p->get_name ());
+  */
 }
 
@@ -4829,10 +4894,4 @@
 
   return (is_in_path);
-}
-
-//----------------------------------------------------------
-bool Use::located () const
-{
-  return (m_located);
 }
 
@@ -5736,6 +5795,21 @@
 
 //----------------------------------------------------------
-Project* Use::get_project ()
+const Project* Use::get_project () const
 {    
+  if (m_project)
+    return m_project;
+
+  return Project::find_by_cmtpath (m_realpath.size ()
+				   ? Project::find_in_cmt_paths (m_realpath, true)
+				   : Project::find_in_cmt_paths (real_path)
+				   );
+  /*
+  cmt_string cmtpath = m_realpath.size ()
+    ? Project::find_in_cmt_paths (m_realpath, true)
+    : Project::find_in_cmt_paths (real_path)
+    ;
+  return Project::find_by_cmtpath (cmtpath);
+  */
+  /*
   Project* p;
   cmt_string cmtpath = "";
@@ -5744,4 +5818,5 @@
   p = Project::find_by_cmtpath (cmtpath);
   return p;   
+  */
 }
 
Index: CMT/v1r25-branch/source/cmt_use.h
===================================================================
--- CMT/v1r25-branch/source/cmt_use.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_use.h	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -128,7 +129,7 @@
   bool get_paths (Use* to, UsePtrVector& list);
 
-  bool located () const;
-
-  void change_path (const cmt_string& path);
+  inline bool located () const { return m_located; }
+
+  void change_path (const cmt_string& path, const Project* project = 0);
   void set_auto_imports (State context_state, State specified_state,
 			 cmt_map <Use*, bool>& visited);
@@ -153,5 +154,6 @@
   ScopeType get_current_scope () const;
 
-  Project* get_project ();
+  const Project* get_project () const;
+  inline void set_project (const Project* project) { m_project = project; }
   cmt_string get_info () const;
   bool is_head_version (const cmt_string& version);
@@ -182,5 +184,5 @@
   bool discarded;                /* discarded by version strategy   */
   bool selected;                 /* used for recursive access       */
-  bool m_located;
+  //  bool m_located;
   bool m_hidden;
   ScopeType initial_scope;
@@ -213,5 +215,5 @@
 		      bool skip_discarded = false, ostream& out = cout);
   //  void show_sub_uses (const cmt_string& request, bool skip_discarded = false);
-  bool select_alternate ();
+  bool select_alternate (const Project* project = 0);
   Use* get_selected_version ();
   Use* set_selected_version (Use* selected_use);
@@ -235,4 +237,9 @@
   //cmt_string m_package_name; /* directly read from requirements */
 
+  //  Project* m_project;  /* the project the use is found in */
+  const Project* m_project;  /* the project the use is found in */
+
+  bool m_located;
+
   bool m_has_native_version;
 
Index: CMT/v1r25-branch/source/cmt_vcs.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_vcs.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_vcs.cxx	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by: garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_vcs.h
===================================================================
--- CMT/v1r25-branch/source/cmt_vcs.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_vcs.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/src/Makefile.core
===================================================================
--- CMT/v1r25-branch/src/Makefile.core	(revision 646)
+++ CMT/v1r25-branch/src/Makefile.core	(revision 664)
@@ -2,4 +2,5 @@
 # Copyright Christian Arnault LAL-Orsay CNRS
 # arnault@lal.in2p3.fr
+# Modified by Grigory Rybkin
 # See the complete license in cmt_license.txt "http://www.cecill.info". 
 #-----------------------------------------------------------
Index: CMT/v1r25-branch/src/Makefile.header
===================================================================
--- CMT/v1r25-branch/src/Makefile.header	(revision 646)
+++ CMT/v1r25-branch/src/Makefile.header	(revision 664)
@@ -2,4 +2,5 @@
 # Copyright Christian Arnault LAL-Orsay CNRS
 # arnault@lal.in2p3.fr
+# Modified by Grigory Rybkin
 # See the complete license in cmt_license.txt "http://www.cecill.info". 
 #-----------------------------------------------------------
@@ -198,6 +199,6 @@
 	@echo
 ifndef BCAST_GLOBAL
-	@uses=`$(cmtexe) -private show macros '_project$$|package$$' -tag=$(tags)| \
-	  awk -F = '{if ($$1 ~ /_project$$/) {uses[substr($$1,1,length($$1)-8)]=$$2}else if ($$1 == "package") {cur = $$2;gsub("'\''","",cur)}}END{for (u in uses){if (uses[u]==uses[cur]) print u}}'`; \
+	@uses=`$(cmtexe) -private show macros '_project$$|package$$|_offset$$' -tag=$(tags)| \
+	  awk -F = '{if ($$1 ~ /_project$$/) {p = $$2;gsub("'\''","",p);uses[substr($$1,1,length($$1)-8)]=p} else if ($$1 == "package") {cur = $$2;gsub("'\''","",cur)}else if ($$1 ~ /_offset$$/) {u = substr($$1,1,length($$1)-7);if (!(u in uses))uses[u]=""}}END{for (u in uses){if ((uses[cur] != "" && uses[u] == uses[cur] || u == cur) && u != "CMT" && u != "CMTHOME" && u != "CMTUSERCONTEXT") print u}}'`; \
 	  for u in $${uses}; do \
 	    echo "$${u} : (re)build package $${u} ($(_groups))"; \
@@ -208,6 +209,6 @@
 	  done
 else
-	@uses=`$(cmtexe) -private show macros '_root$$' -tag=$(tags)| \
-	  awk -F = '{u=substr($$1,1,length($$1)-5);if (u != "CMT" && u != "CMTHOME" && u != "CMTUSERCONTEXT") print u}'`; \
+	@uses=`$(cmtexe) -private show macros '_project$$|package$$|_offset$$' -tag=$(tags)| \
+	  awk -F = '{if ($$1 ~ /_project$$/) {p = $$2;gsub("'\''","",p);uses[substr($$1,1,length($$1)-8)]=p} else if ($$1 == "package") {cur = $$2;gsub("'\''","",cur)}else if ($$1 ~ /_offset$$/) {u = substr($$1,1,length($$1)-7);if (!(u in uses))uses[u]=""}}END{for (u in uses){if (uses[u] != uses[cur] && (uses[u] == "CMTHOME" || uses[u] == "CMTUSERCONTEXT")) {continue} else if (u != "CMT" && u != "CMTHOME" && u != "CMTUSERCONTEXT") print u}}'`; \
 	  for u in $${uses}; do \
 	    echo "$${u} : (re)build package $${u} ($(_groups))"; \
Index: CMT/v1r25-branch/src/NMakefile.core
===================================================================
--- CMT/v1r25-branch/src/NMakefile.core	(revision 646)
+++ CMT/v1r25-branch/src/NMakefile.core	(revision 664)
@@ -2,4 +2,5 @@
 # Copyright Christian Arnault LAL-Orsay CNRS
 # arnault@lal.in2p3.fr
+# Modified by Grigory Rybkin
 # See the complete license in cmt_license.txt "http://www.cecill.info". 
 #-----------------------------------------------------------
Index: CMT/v1r25-branch/src/NMakefile.header
===================================================================
--- CMT/v1r25-branch/src/NMakefile.header	(revision 646)
+++ CMT/v1r25-branch/src/NMakefile.header	(revision 664)
@@ -2,4 +2,5 @@
 # Copyright Christian Arnault LAL-Orsay CNRS
 # arnault@lal.in2p3.fr
+# Modified by Grigory Rybkin
 # See the complete license in cmt_license.txt "http://www.cecill.info". 
 #-----------------------------------------------------------
Index: CMT/v1r25-branch/src/cleanup.bash
===================================================================
--- CMT/v1r25-branch/src/cleanup.bash	(revision 664)
+++ CMT/v1r25-branch/src/cleanup.bash	(revision 664)
@@ -0,0 +1,16 @@
+#-----------------------------------------------------------
+# Copyright Christian Arnault LAL-Orsay CNRS
+# arnault@lal.in2p3.fr
+# Written by Grigory Rybkin
+# See the complete license in cmt_license.txt "http://www.cecill.info". 
+#-----------------------------------------------------------
+
+if complete -p cmt >/dev/null 2>&1; then
+  complete -r cmt
+fi
+
+unset -f _cmt
+
+unset -f _cmt_escape_compreply
+
+shopt -u extglob
Index: CMT/v1r25-branch/src/cleanup.csh
===================================================================
--- CMT/v1r25-branch/src/cleanup.csh	(revision 646)
+++ CMT/v1r25-branch/src/cleanup.csh	(revision 664)
@@ -2,23 +2,74 @@
 # Copyright Christian Arnault LAL-Orsay CNRS
 # arnault@lal.in2p3.fr
+# Modified by Grigory Rybkin
 # See the complete license in cmt_license.txt "http://www.cecill.info". 
 #-----------------------------------------------------------
 
-set newpath=
+unsetenv CMTBIN
+unsetenv CMTCONFIG
 
-foreach p ( `echo ${PATH} | sed 's#:# #g'` )
-  echo ${p} | egrep '/CMT/' >& /dev/null
-  set s=${status}
-  if ( "${s}" != 0 ) then
-    if ( ${newpath} == "" ) then
-      set newpath=${p}
+if ( $?CMTROOT == 1 ) then
+if ( $?0 == 0 ) then
+if ( $?tcsh == 1 ) then
+  source ${CMTROOT}/src/cleanup.tcsh
+else if ( "${shell:t}" == "tcsh" ) then
+  source ${CMTROOT}/src/cleanup.tcsh
+endif
+endif
+endif
+
+unsetenv CMTROOT
+
+# Remove CMT entries, if any
+set newpath=()
+foreach p (${path:q})
+  if ( "${p}" !~ "*/CMT/*" ) then
+    if ( ${#newpath} != 0 ) then
+      set newpath=(${newpath:q} ${p:q})
     else
-      set newpath=${newpath}:${p}
+      set newpath=(${p:q})
     endif
   endif
 end
 
-setenv PATH ${newpath}
-unsetenv CMTCONFIG
-unsetenv CMTROOT
+set path=(${newpath:q})
+unset newpath
 
+unalias cmt
+
+if ( $?CLASSPATH == 1 ) then
+if ( "${CLASSPATH}" =~ "*/CMT/*" ) then
+# Remove CMT entries
+  set _p="${CLASSPATH}"
+  while ( "$_p" =~ "*:*" )
+  set _p="${_p:s/:/ /}"
+  end
+
+  set newpath=
+  foreach p (${_p})
+    if ( "${p}" !~ "*/CMT/*" ) then
+      if ( "${newpath}" != "" ) then
+        set newpath=${newpath}:${p}
+      else
+        set newpath=${p}
+      endif
+    endif
+  end
+
+  if ( "${newpath}" != "" ) then
+    setenv CLASSPATH ${newpath}
+  else
+    unsetenv CLASSPATH
+  endif
+  unset _p newpath
+endif
+endif
+
+unalias jcmt
+
+# Unset MAKEFLAGS, if looks set by CMT
+if ( $?MAKEFLAGS == 1 ) then
+if ( "$MAKEFLAGS" =~ "*QUICK=1" ) then
+  unsetenv MAKEFLAGS
+endif
+endif
Index: CMT/v1r25-branch/src/cleanup.sh
===================================================================
--- CMT/v1r25-branch/src/cleanup.sh	(revision 646)
+++ CMT/v1r25-branch/src/cleanup.sh	(revision 664)
@@ -2,20 +2,80 @@
 # Copyright Christian Arnault LAL-Orsay CNRS
 # arnault@lal.in2p3.fr
+# Modified by Grigory Rybkin
 # See the complete license in cmt_license.txt "http://www.cecill.info". 
 #-----------------------------------------------------------
 
-newpath=""
-for p in `echo ${PATH} | sed 's/:/ /g'`; do
-  if test ! "`echo ${p} | egrep CMT`" ; then
-    if test "${newpath}" = "" ; then
-      newpath=${p}
-    else
-      newpath=${newpath}:${p}
+[ -z ${CMTBIN+CMT} ] || unset CMTBIN
+[ -z ${CMTCONFIG+CMT} ] || unset CMTCONFIG
+
+if [ "${CMTROOT+CMT}" = CMT ]; then
+if [ -n "$-" ] && [ "${-#*i}" != "$-" ]; then
+if [ -n "${ZSH_NAME-}" ]; then
+  . ${CMTROOT}/src/cleanup.zsh
+elif [ -n "${BASH-}" ]; then
+  . ${CMTROOT}/src/cleanup.bash
+fi
+fi
+fi
+
+[ -z ${CMTROOT+CMT} ] || unset CMTROOT
+
+cmt_clean_path()
+{
+# Remove CMT entries, if any
+  _np=
+  _p="$1"
+  while [ -n "$_p" ]; do
+    __p="${_p#:}"
+    while [ "$__p" != "$_p" ]; do
+      _p="${__p}"
+      __p="${_p#:}"
+    done
+    _e="${_p%%:*}"
+    _p="${_p#${_e}}"
+    if [ "${_e%/CMT/*}" = "${_e}" ] && [ -n "${_e}" ]; then
+      if [ -n "${_np}" ]; then
+        _np="${_np}:${_e}"
+      else
+        _np="${_e}"
+      fi
     fi
+  done
+  echo "$_np"
+  unset _np _p __p _e
+}
+
+if [ "${PATH%/CMT/*}" != "${PATH}" ]; then
+  newpath=`cmt_clean_path "${PATH}"`
+  PATH=${newpath}
+  unset newpath
+fi
+
+if alias cmt >/dev/null 2>&1; then
+  unalias cmt
+fi
+
+if [ -n "${CLASSPATH-}" ]; then
+if [ "${CLASSPATH%/CMT/*}" != "${CLASSPATH}" ]; then
+  newpath=`cmt_clean_path "${CLASSPATH}"`
+  if [ -n "${newpath}" ]; then
+    CLASSPATH=${newpath}
+  else
+    unset CLASSPATH
   fi
-done
+  unset newpath
+fi
+fi
 
-PATH=${newpath}; export PATH
+if alias jcmt >/dev/null 2>&1; then
+  unalias jcmt
+fi
 
-CMTCONFIG=; export CMTCONFIG
-CMTROOT=; export CMTROOT
+unset -f cmt_clean_path
+
+# Unset MAKEFLAGS, if looks set by CMT
+if [ "${MAKEFLAGS+CMT}" = CMT ]; then
+if [ "${MAKEFLAGS%QUICK=1}" != "${MAKEFLAGS}" ]; then
+  unset MAKEFLAGS
+fi
+fi
Index: CMT/v1r25-branch/src/cleanup.tcsh
===================================================================
--- CMT/v1r25-branch/src/cleanup.tcsh	(revision 664)
+++ CMT/v1r25-branch/src/cleanup.tcsh	(revision 664)
@@ -0,0 +1,8 @@
+#-----------------------------------------------------------
+# Copyright Christian Arnault LAL-Orsay CNRS
+# arnault@lal.in2p3.fr
+# Written by Grigory Rybkin
+# See the complete license in cmt_license.txt "http://www.cecill.info". 
+#-----------------------------------------------------------
+
+uncomplete cmt
Index: CMT/v1r25-branch/src/cleanup.zsh
===================================================================
--- CMT/v1r25-branch/src/cleanup.zsh	(revision 664)
+++ CMT/v1r25-branch/src/cleanup.zsh	(revision 664)
@@ -0,0 +1,14 @@
+#-----------------------------------------------------------
+# Copyright Christian Arnault LAL-Orsay CNRS
+# arnault@lal.in2p3.fr
+# Written by Grigory Rybkin
+# See the complete license in cmt_license.txt "http://www.cecill.info". 
+#-----------------------------------------------------------
+
+[ -z "${ARGC-}" ] && return
+
+compctl + cmt.exe
+
+for fn in $(functions -m + 'cmt_*'); do
+  unset -f $fn
+done
Index: CMT/v1r25-branch/src/setup.csh
===================================================================
--- CMT/v1r25-branch/src/setup.csh	(revision 646)
+++ CMT/v1r25-branch/src/setup.csh	(revision 664)
@@ -6,5 +6,11 @@
 #-----------------------------------------------------------
 
-setenv CMTBIN `uname`-`uname -m | tr -d ' '`
+# Remove spaces, if any
+set _m="`uname -m`"
+while ( "$_m" =~ "* *" )
+set _m="${_m:s/ //}"
+end
+setenv CMTBIN `uname`-"$_m"
+unset _m
 
 if ( $?CMTCONFIG == 0 ) then
@@ -15,23 +21,25 @@
 if ( $?tcsh == 1 ) then
   source ${CMTROOT}/src/setup.tcsh
-else if ( `basename "$shell"` == "tcsh" ) then
+else if ( "${shell:t}" == "tcsh" ) then
   source ${CMTROOT}/src/setup.tcsh
 endif
 endif
 
+# Remove CMT entries, if any
 set newpath=()
-foreach p (${path})
+foreach p (${path:q})
   if ( "${p}" !~ "*/CMT/*" ) then
     if ( ${#newpath} != 0 ) then
-      set newpath=(${newpath} ${p})
+      set newpath=(${newpath:q} ${p:q})
     else
-      set newpath=(${p})
+      set newpath=(${p:q})
     endif
   endif
 end
 
-set path=(${newpath} "${CMTROOT}/${CMTBIN}")
+set path=(${newpath:q} "${CMTROOT}/${CMTBIN}")
+unset newpath
+
 alias cmt '${CMTROOT}/${CMTBIN}/cmt.exe'
-unset newpath
 
 if ( $?CLASSPATH == 0 ) then
@@ -42,6 +50,12 @@
   setenv CLASSPATH ${CLASSPATH}:${CMTROOT}/java/cmt.jar
 else
+# Remove CMT entries
+  set _p="${CLASSPATH}"
+  while ( "$_p" =~ "*:*" )
+  set _p="${_p:s/:/ /}"
+  end
+
   set newpath=
-  foreach p ( `echo ${CLASSPATH} | tr ':' ' '` )
+  foreach p (${_p})
     if ( "${p}" !~ "*/CMT/*" ) then
       if ( "${newpath}" != "" ) then
@@ -58,5 +72,5 @@
     setenv CLASSPATH ${CMTROOT}/java/cmt.jar
   endif
-  unset newpath
+  unset _p newpath
 endif
 
Index: CMT/v1r25-branch/src/setup.sh
===================================================================
--- CMT/v1r25-branch/src/setup.sh	(revision 646)
+++ CMT/v1r25-branch/src/setup.sh	(revision 664)
@@ -6,5 +6,17 @@
 #-----------------------------------------------------------
 
-CMTBIN=`uname`-`uname -m | tr -d ' '`; export CMTBIN
+# Remove spaces, if any
+_m="`uname -m`"
+_nm=
+while [ -n "$_m" ]; do
+  _t="${_m#?}"
+  _a="${_m%${_t}}"
+  if [ "${_a}" != " " ]; then
+    _nm="${_nm}${_a}"
+  fi
+  _m="$_t"
+done
+CMTBIN=`uname`-"$_nm"; export CMTBIN
+unset _m _nm _t _a
 
 if test "${CMTCONFIG}" = "" ; then
@@ -20,23 +32,38 @@
 fi
 
+cmt_clean_path()
+{
+# Remove CMT entries, if any
+  _np=
+  _p="$1"
+  while [ -n "$_p" ]; do
+    __p="${_p#:}"
+    while [ "$__p" != "$_p" ]; do
+      _p="${__p}"
+      __p="${_p#:}"
+    done
+    _e="${_p%%:*}"
+    _p="${_p#${_e}}"
+    if [ "${_e%/CMT/*}" = "${_e}" ] && [ -n "${_e}" ]; then
+      if [ -n "${_np}" ]; then
+        _np="${_np}:${_e}"
+      else
+        _np="${_e}"
+      fi
+    fi
+  done
+  echo "$_np"
+  unset _np _p __p _e
+}
+
 if [ "${PATH%/CMT/*}" = "${PATH}" ]; then
   PATH=${PATH}:${CMTROOT}/${CMTBIN}; export PATH
 else
-  newpath=
-  for p in `echo ${PATH} | tr ':' ' '`; do
-    if [ "${p%/CMT/*}" = "${p}" ]; then
-      if [ -n "${newpath}" ]; then
-        newpath=${newpath}:${p}
-      else
-        newpath=${p}
-      fi
-    fi
-  done
-
+  newpath=`cmt_clean_path "${PATH}"`
   PATH=${newpath}:${CMTROOT}/${CMTBIN}; export PATH
   unset newpath
 fi
 
-alias cmt='${CMTROOT}/${CMTBIN}/cmt.exe'; export cmt
+alias cmt='${CMTROOT}/${CMTBIN}/cmt.exe'
 
 if [ -z "${CLASSPATH-}" ]; then
@@ -45,15 +72,5 @@
   CLASSPATH=${CLASSPATH}:${CMTROOT}/java/cmt.jar; export CLASSPATH
 else
-  newpath=
-  for p in `echo ${CLASSPATH-} | tr ':' ' '`; do
-    if [ "${p%/CMT/*}" = "${p}" ]; then
-      if [ -n "${newpath}" ]; then
-        newpath=${newpath}:${p}
-      else
-        newpath=${p}
-      fi
-    fi
-  done
-
+  newpath=`cmt_clean_path "${CLASSPATH}"`
   if [ -n "${newpath}" ]; then
     CLASSPATH=${newpath}:${CMTROOT}/java/cmt.jar; export CLASSPATH
@@ -64,5 +81,7 @@
 fi
 
-alias jcmt='(java cmt_parser)'; export jcmt
+alias jcmt='(java cmt_parser)'
+
+unset -f cmt_clean_path
 
 # Set MAKEFLAGS, if unset (similar to NPROC with Plan 9 mk utility)
Index: CMT/v1r25-branch/src/setup.tcsh
===================================================================
--- CMT/v1r25-branch/src/setup.tcsh	(revision 646)
+++ CMT/v1r25-branch/src/setup.tcsh	(revision 664)
@@ -2,5 +2,6 @@
 # Copyright Christian Arnault LAL-Orsay CNRS
 # arnault@lal.in2p3.fr
-# Modified by garonne@lal.in2p3.fr, Grigory Rybkin
+# Modified by garonne@lal.in2p3.fr
+# Modified by Grigory Rybkin
 # See the complete license in cmt_license.txt "http://www.cecill.info". 
 #-----------------------------------------------------------
Index: CMT/v1r25-branch/src/setup.zsh
===================================================================
--- CMT/v1r25-branch/src/setup.zsh	(revision 646)
+++ CMT/v1r25-branch/src/setup.zsh	(revision 664)
@@ -2,5 +2,6 @@
 # Copyright Christian Arnault LAL-Orsay CNRS
 # arnault@lal.in2p3.fr
-# Modified by garonne@lal.in2p3.fr, Grigory Rybkin
+# Modified by garonne@lal.in2p3.fr
+# Modified by Grigory Rybkin
 # See the complete license in cmt_license.txt "http://www.cecill.info". 
 #-----------------------------------------------------------
